# BEGIN COPYRIGHT
# *************************************************************************
#
# These are as-is scripts given only as a guide.
# 5724-M24
# (C) Copyright IBM Corporation 2010, 2011
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
#
# *************************************************************************
# END COPYRIGHT

from java.lang import System
import zipfile,os

print "*************************************************************************************"
print "start: init"
print ""

fileSeparator = System.getProperty("file.separator");
configUtilsScript = System.getProperty("was.install.root") + fileSeparator + "util" + fileSeparator + "config" + fileSeparator + "admin" + fileSeparator + "configUtils.py"
print "load configuration utils from ", configUtilsScript
execfile(configUtilsScript);

print ""
print "end: init"

#*******************************************************************************************************
# upgradeWESBwidgets
#*******************************************************************************************************
def upgradeWESBwidgets(nodeName, serverName, clusterName):
  print "start: upgradeWESBwidgets(), nodeName = ", nodeName, ", serverName = ", serverName, ",clusterName = ", clusterName;
  print "";
  
  if ( clusterName and (isEmptyString(clusterName) != "True") ):
    updateScopeArgs = '-clusterName "' + clusterName + '"'
  elif (( nodeName and (isEmptyString(nodeName) != "True")) and (serverName and (isEmptyString(serverName) != "True"))):
    updateScopeArgs = '-serverName "' + serverName + '" -nodeName "' + nodeName + '"'    
  #endif

  print "updateScopeArgs = ", updateScopeArgs;
  
  #check to see if the profile should be upgraded
  upgradeProfileFlag = 0
  
  if ( AdminTask.getBusinessSpaceDeployStatus('[' + updateScopeArgs + ']') == "true"):
    print "Business space is configured on ", updateScopeArgs    
    
    applications = getObjectArray(AdminApp.list());
    
    for application in applications:
        if( (String(application)).indexOf("wesbWidget") == 0 ):
            if( isApplicationInstalledAt(application, getDeploymentTargetContextAt(nodeName, serverName, clusterName)) == "True"):
                upgradeProfileFlag = 1;
                break;
    #endFor
    
    if( upgradeProfileFlag == 0 ):
		print "wesbWidget not installed on ", updateScopeArgs    
  else:
    print "Business space is not configured on ", updateScopeArgs

  print "Upgrade the profile?: ", repr(upgradeProfileFlag)
  
  if (upgradeProfileFlag):

    #Update widgets
    updateWidgetsArgs = '[' + updateScopeArgs  
    updateWidgetsArgs = updateWidgetsArgs + ' -widgets "' +wasHome + '/BusinessSpace/widgets/WESB/wesbWidget.zip"' 
    updateWidgetsArgs = updateWidgetsArgs + ' -save "false"'  + ' -noEndpoints "true"' + ']'

    print "updateWidgetsArgs: ", updateWidgetsArgs
    AdminTask.updateBusinessSpaceWidgets(updateWidgetsArgs)

    AdminConfig.save()    
    print "";
    print "The WESBwidgets upgrade complete on target ", updateScopeArgs
  else:
    #The profile upgrade not necessary for this target.
    print "The profile upgrade is not necessary on target ", updateScopeArgs
  #endif

  print ""
  print "end: upgradeWESBwidgets()"

#enddef

#Main

#initialize the variables
nodeName = None;
serverName = None;
clusterName = None;
wasHome = System.getProperty("was.install.root");

print "*************************************************************************************"
print "start: upgradeWESBwidgets upgrade"
print ""
try:
    cellType = getCellType();
    
    if cellType == 'STANDALONE':
        print "Upgrading the stand-alone profile"
        nodeName = System.getProperty("local.node");
        serverName = getLocalServerName();          
        upgradeWESBwidgets(nodeName, serverName, clusterName);        
                                        
    elif cellType == 'DISTRIBUTED':
        print "Upgrading the distributed (dmgr or customized) profile"
        # check whether the local node is a deployment manager Node
        isDMgrNode = isDMgrNode();
            
        if (isDMgrNode != "False"):
            clusterName = System.getProperty("bpm.upgrade.cluster.name");
            if (not (clusterName)) or (isEmptyString(clusterName) == "True"):
                print "Skipping upgrade for dmgr"
            else:
                print ""
                print "Upgrading the cluster ", clusterName;
                upgradeWESBwidgets(nodeName, serverName, clusterName);
                                
        else:        
            print "Upgrading the distributed custom profile"
            
            nodeID = AdminConfig.getid(getCellContext() + getNodeContext("use-local-server"));            
            print ""
            print "The value of nodeID is ", nodeID;

            servers = getObjectArray(AdminConfig.list("Server", nodeID));
            
            for server in servers:
                serverType = AdminConfig.showAttribute(server, "serverType");
                print ""
                print "The value of serverType is ", serverType
                
                if (serverType == "APPLICATION_SERVER"):
                    serverName = AdminConfig.showAttribute(server, "name");
                    print "The value of serverName is ", serverName
                    
                    clusterName = AdminConfig.showAttribute(server, "clusterName");
                    print "The value of clusterName is ", clusterName
                    
                    if (not (clusterName)) or (isEmptyString(clusterName) == "True"):
                        print "Upgrading server ", serverName, " on Node ", System.getProperty("local.node");                                               
                        nodeName = System.getProperty("local.node");                        
                        upgradeWESBwidgets(nodeName, serverName, clusterName);                        
                    else:
                        print "Skipping the upgrade for cluster members"                         
    else:
        print "Unknown cell type"
except:
    print "Cannot upgrade BPMConfigurationWidgets. The exception type is: ", sys.exc_type, ". The exception description is: ", sys.exc_value      
                
            
print 
print ""
print "end: upgrade of WESB widgets"
print "*************************************************************************************"
print
#end Main
