-- @start_restricted_prolog@
-- Licensed Materials - Property of IBM
-- 
-- 5724-I82 5724-L01 5655-N53 5655-R15 5655-N63               
-- Copyright IBM Corporation 2006, 2010 All Rights Reserved.
-- US Government Users Restricted Rights- Use, duplication or disclosure
-- restricted by GSA ADP Schedule Contract with IBM Corp.
-- @end_restricted_prolog@

-- DB2UDB for z/OS V8.1 schema for Message Logger Mediation

-- @DB_NAME@    DBName
-- @STOGRP@     StorageGroup
-- @SCHEMA@     SQLID

-- Create Tablespaces
CREATE TABLESPACE ESBTS
 IN @DB_NAME@ USING STOGROUP @STOGRP@
 CCSID UNICODE
 DEFINE NO
 SEGSIZE 32
 LOCKSIZE ANY
 BUFFERPOOL @BPTABLE4K@;

CREATE LOB TABLESPACE ESBCLOB
 IN @DB_NAME@
 USING STOGROUP @STOGRP@
 LOCKSIZE LOB
 BUFFERPOOL @BPLOB4K@;

-- Create Tables
CREATE TABLE @SCHEMA@.MSGLOG
  (TIMESTAMP TIMESTAMP NOT NULL,
   MESSAGEID VARCHAR(36) NOT NULL,
   MEDIATIONNAME VARCHAR(256) NOT NULL,
   MODULENAME VARCHAR(256),
   MESSAGE CLOB(100000K),
   VERSION VARCHAR(10),
CONSTRAINT PK_MSGLOG PRIMARY KEY (MESSAGEID, TIMESTAMP, MEDIATIONNAME))
   IN @DB_NAME@.ESBTS;

CREATE UNIQUE INDEX @SCHEMA@.MSGLOG_INDEX_PK 
ON @SCHEMA@.MSGLOG (MESSAGEID, TIMESTAMP, MEDIATIONNAME)
 USING STOGROUP @STOGRP@
 DEFINE NO
 NOT PADDED
 BUFFERPOOL @BPINDEX@;

-- Create AUX CLOB Tables/Index 
CREATE AUX TABLE @SCHEMA@.MESSAGECLOB
   IN @DB_NAME@.ESBCLOB STORES @SCHEMA@.MSGLOG COLUMN MESSAGE;

CREATE INDEX @SCHEMA@.MESSAGECLOB_IDX
 ON @SCHEMA@.MESSAGECLOB
 USING STOGROUP @STOGRP@
 BUFFERPOOL @BPINDEX@;

